"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleUnknownArgs = void 0;
const help_1 = require("../help");
const args_1 = __importDefault(require("./args"));
const messages_1 = require("./messages");
const handleUnknownArgs = () => {
    const flags = args_1.default['_unknown'];
    if (!(flags.length === 1 && (flags[0] === '--help' || flags[0] === '-h'))) {
        const message = `${flags.join(', ')} does not exists as a valid command.`;
        (0, messages_1.warn)(message);
    }
    (0, help_1.printHelp)();
};
exports.handleUnknownArgs = handleUnknownArgs;
