"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deleteBySelection = exports.del = void 0;
const messages_1 = require("./cli/messages");
const selection_1 = require("./cli/selection");
const del = async (prefix, suffix, version, api) => {
    let res = '';
    try {
        res = await api.deployDelete(prefix, suffix, version);
    }
    catch (err) {
        (0, messages_1.apiError)(err);
    }
    return res;
};
exports.del = del;
const deleteBySelection = async (api) => {
    try {
        const deployments = (await api.inspect()).filter(dep => dep.status === 'ready');
        if (!deployments.length)
            (0, messages_1.error)('No deployment found');
        const project = await (0, selection_1.listSelection)([...deployments.map(el => `${el.suffix} ${el.version}`)], 'Select the deployment to delete:');
        const app = deployments.filter(dep => dep.suffix === project.split(' ')[0] &&
            dep.version === project.split(' ')[1])[0];
        (0, messages_1.info)(await (0, exports.del)(app.prefix, app.suffix, app.version, api));
    }
    catch (err) {
        (0, messages_1.error)(String(err));
    }
};
exports.deleteBySelection = deleteBySelection;
// This can be better
