"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.logs = void 0;
const deployment_1 = require("@metacall/protocol/deployment");
const language_1 = require("@metacall/protocol/language");
const protocol_1 = __importStar(require("@metacall/protocol/protocol"));
const args_1 = __importDefault(require("./cli/args"));
const messages_1 = require("./cli/messages");
const selection_1 = require("./cli/selection");
const startup_1 = require("./startup");
const utils_1 = require("./utils");
const showLogs = async (container, suffix, type, dev) => {
    const config = await (0, startup_1.startup)(args_1.default['confDir']);
    const api = (0, protocol_1.default)(config.token, dev ? config.devURL : config.baseURL);
    (0, messages_1.info)(`Getting ${type} logs for ${suffix}...`);
    let logsTill = [''];
    let app;
    let status = 'create';
    while (status !== 'ready') {
        app = (await api.inspect()).filter(dep => dep.suffix === suffix)[0];
        status = app.status;
        const prefix = app.prefix;
        try {
            const allLogs = await api.logs(container, type, suffix, prefix);
            allLogs.split('\n').forEach(el => {
                if (!logsTill.includes(el))
                    console.log(el);
            });
            logsTill = allLogs.split('\n');
        }
        catch (err) {
            if ((0, protocol_1.isProtocolError)(err))
                continue;
        }
        await (0, utils_1.sleep)(10000);
    }
};
const logs = async (containers, suffix, dev) => {
    try {
        const container = await (0, selection_1.listSelection)(containers.reduce((choices, runner) => [
            ...choices,
            {
                name: (0, language_1.RunnerToDisplayName)(runner),
                value: runner
            }
        ], [
            {
                name: 'Deploy',
                value: 'deploy'
            }
        ]), 'Select a container to get logs');
        const type = container === 'deploy' ? deployment_1.LogType.Deploy : deployment_1.LogType.Job;
        await showLogs(container, suffix, type, dev);
    }
    catch (e) {
        (0, messages_1.error)(String(e));
    }
};
exports.logs = logs;
